/**
<p>
 WbzApply can be used as <code>wbz:apply-templates</code>,
 <code>wbz:call-template</code>, <code>wbz:for-each</code> and
 <code>wbz:apply-imports</code>. The configuration
 of this component is according to the XSLT-Specifications
 of <code>xsl:apply-templates</code>,
 <code>xsl:call-template</code>, <code>xsl:for-each</code> and
 <code>xsl:apply-imports</code>.
</p>

<p> You can use <code>wbz:with-param</code> with
 <code>wbz:call-template</code> and
 <code>wbz:apply-templates</code>. You can use <code>wbz:sort</code>
 with <code>wbz:apply-templates</code> and <code>wbz:for-each</code>.
</p> 

Sample configuration for <code>apply-templates</code> :


<pre class="source">
    &lt;wbz:apply-templates select="*"/>
</pre>

Sample configuration for <code>for-each</code> :

<pre class="source">
    &lt;wbz:for-each select="books">
      &lt;wbz:sort select="&#64;name"/>
      &lt;wbz:value-of select="&#64;name"/>
    &lt;/wbz:for-each>
</pre>

Sample configuration for <code>call-template</code>:

<pre class="source">
    &lt;wbz:call-template name="validateEmail">
      &lt;wbz:with-param name="email" select="&#64;email"/>
    &lt;/wbz:call-template>
</pre>

<p>When using <code>wbz:for-each</code> the context entry
   <code>wobzilla.position</code> is updated for every
   child-<em>view</em> to reflect the current possition
   in the loop. See <a href="ContextXPathResolver.html">ContextXPathResolver</a>.
</p>


  @requires wobzilla_viewFactory
  @requires wobzilla_componentFactory
  @requires wobzilla_variableFactory
  @requires wobzilla_sortFactory
  @requires wobzilla_xpath

  @constructor
*/
function WbzApply() {
    function dummy();
}

