/** 
 This component can be used for conditional processing.
 The configuration is according to the XSLT-Specifications
 of <code>xsl:choose</code> and <code>xsl:if</code>.
 <p>
 Sample configuration for <code>wbz:if</code> :
 </p>
  
 <pre class="source">
  &lt;wbz:if test="string-length(name) = 0">
    &lt;html:span class="warning">No name&lt;/html:span>
  &lt;/wbz:if>
 </pre>

 <p>
 Sample configuration for <code>wbz:choose</code> :
 </p>

 <pre class="source">
    &lt;wbz:choose>
     &lt;wbz:when test="string-length($title)&lt;10">
      &lt;html:span class="errorMessage">Title too short!&lt;/html:span>
     &lt;/wbz:when>
     &lt;wbz:when test="string-length($title)&lt;20">
      &lt;html:span class="warningMessage">This is a short title!&lt;/html:span>
     &lt;/wbz:when>
     &lt;wbz:otherwise>
       !A good title!
     &lt;/wbz:otherwise>
    &lt;/wbz:choose>
 </pre>

  @requires wobzilla_xpath
  @requires wobzilla_componentFactory

  @constructor
*/
function WbzChoose() {
    function dummy();
}

