/** 
   <p> 
    <code>WbzContainer</code> allows the embedding <em>views</em>
    into an host language lile <em>HTML</em> or <em>XUL</em>. There is
    no equivalent in XSLT. In XSLT these elements can be written in
    the so called <em>template-bodies</em> under the most elements (see
    <a href="http://www.w3.org/TR/xslt">XSLT-specification</a>).
    Wobzilla can also use this notation, by transparently wrapping
    those elements under an <code>WbzContainer</code> see below.
   </p>

   <h2>Embedding of components into a host-language</h2>   
   <p>
     Enables the use of templates in Wobzilla. The following examples 
     shows the embedding into a HTML-Table:
     </p>
 <pre>
&lt;wbz:container>
 &lt;html:table>
  &lt;html:tr>
   &lt;html:td>firstname:&lt;/html:td>
   &lt;html:td>&lt;wbz:value-of select="&#64;firstname"/>&lt;/html:td>
  &lt;/html:tr>
  &lt;html:tr>
   &lt;html:td>Lastname:&lt;/html:td>
   &lt;html:td>&lt;wbz:value-of select="&#64;lastname"/>&lt;/html:td>
  &lt;/html:tr>
 &lt;/html:table>
&lt;/wbz:container>
</pre> 

  <h2>Aggregation of multiple <em>views</em></h2>   
    <p>
     <code>WbzContainer</code> can be used to aggregate multiple <em>views</em>.
     That should simplify the managemant of child-<em>views</em> 
     for other components. They only need to take care of the one container-child.
     The components can automaticaly create a <code>wbz:container</code>
     if they find more than one <em>view</em>-configuration or an element,
     that doesn't belong to the wbz:namespace. Theres the helper method
     <a href="[default context].html#WBZ_wrapChildConfigs">WBZ_wrapConfig</a>.
     All components provied by mozilla use this method, to make the
     use of the WbzContainer transparent to the creator of the stylesheet.
     They can use the XSLT-syntax without the container-instruction. 
     But you will encounter the <code>container</code> notation in the samples and 
     in the API. This is to point up the interaction of the inidividual components.
    </p>

  <h2>Use of local variables</h2> 
    <p> Local variables must be declared
    at the start of a container-configuration.  The container passes
    all <code>variable</code> instructions to the <a
    href="wobzilla_variableFactory.html">wobzilla.variableFactory</a>
    that creates a <a
    href="wobzilla_variableHandler.html">wobzilla.variableHandler</a>.
    This handler evalutates the variables and writes the result it
    into the context entry <code>wobzilla.local</code>.
     All sub-views of the container can
     access this variable through <code>wobzilla.local</code>.
    </p>
    <p>
     In the <code>requery</code>-method of the container, 
     first the <code>requery</code>-method of the variableHandler is
     called, to check if a variable value has changed, and
     update the context if neccessary.
     If it has changed, the <code>localVariableChanged</code> flag will be
     set on the changeEvent to notify all childs of the container, so they can
     perform recalculations, where they are neccessary.
    </p>

  @requires wobzilla_xpath
  @requires wobzilla_variableFactory
  @requires wobzilla_componentFactory
  @constructor
*/
function WbzContainer() {
    function dummy();
}

