/* This file is only used for documentation purpose */


/** JavaScript-port of <a href="http://avalon.apache.org/api/org/apache/avalon/framework/logger/Logger.html" target="_top">avalon logging interface</a>.
  @constructor
 */
function avalon_logger(INTERFACE_ONLY_NO_CONSTRUCTOR) {
    /** read-only property you can use to test, if the logger should
        output debugging information. You can check this properties
        before calling debug() to avoid costly creation of debugging
        messages. 
        <p>Note:</p> Due to a bug in jsdoc, properties aren't displayed
        in the documentation. <code>debugging</code> is a property,
        use <code>logger.debugging</code>
        instead of <code>logger.debugging()</code>.
     */
    this.debugging = function();

    /** Logs a message with debugging priority.*/
    this.debug = function(message);
    /** Logs a message with info priority.*/
    this.info = function(message);
    /** Logs a message with warn priority.*/
    this.warn = function(message);
    /** Logs a message with error priority.*/
    this.error = function(exception);
    /** Create a new child logger. The name of the child logger is [current-loggers-name].[passed-in-name] */
    this.getChildLogger = function(childCategory);

   
}

/** JavaScript-port of <a href="http://avalon.apache.org/api/org/apache/avalon/framework/context/Context.html" target="_top">avalon context interface</a>. 

It has an additional <code>has</code> method (analog to the <a href="avalon_serviceManager.html">serviceManager</a> interface).
  @constructor
 */
function avalon_context(INTERFACE_ONLY_NO_CONSTRUCTOR) {
    /** returns if there is a context entry with the specified key.
        @param key the key-string.
     */
    this.has = function(key);
    /** returns the context entry with the specified key.
        @param key the key-string.
        @throws ContextException, if theres no such entry.*/
    this.get = function(key);
}

/** JavaScript-port of <a href="http://avalon.apache.org/api/org/apache/avalon/framework/service/ServiceManager.html" target="_top">avalon serviceManager interface</a>. 
  @constructor
 */
function avalon_serviceManager(INTERFACE_ONLY_NO_CONSTRUCTOR) {
    /** returns the service for the specified role.
        @param role the role-string.
     */
    this.lookup = function(role);
    /** returns if there is a service for the specified role.
        @param role the role-string.
     */
    this.hasService = function(role);
}


