WOBZILLA_NS="http://wobzilla.sf.net/views";
var XUL_NS="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

/** bootstrap wobzilla. This method creates an instance of WobzillaEngine.
 */
function wobzillaStart() {
    //WBZ_setDebuggingLevel(DEBUG_LEVEL);
    WBZ_setDebuggingLevel(INFO_LEVEL);
    var engine = new WobzillaEngine();
    //engine.viewFile = demos[demo].view;
    //engine.contentFile = demos[demo].data;
    engine.init();
}

function WobzillaEngine() {
    this.viewFile;
    this.contentFile;
    _this = this;

    var _rootView;
    var _xmlContent;
    var _demos;
    var _log = new DefaultLogger("wbz", document.getElementById('log_window'));

    var _container;
    var _sm;
    var _cf;
    var _rootContext = new DefaultContext();
    
    _rootContext.put("wobzilla_version","0.3");
    _rootContext.put("wobzilla_xpath_profile","false()");

    this.init = function() {
        try {
            var configDoc = _this.load("wobzillaConf.xml");
            var config = WBZ_getFirstElement(configDoc);
            _demos = WBZ_getElements(WBZ_getChildsByTagName(config,"demos")[0]);
            var shortcutConfig = WBZ_getChildsByTagName(config,"shortcuts")[0];
            var frames = window.frames;
            for (var f = 0; f < frames.length; f++) {
               frames[f].document.addEventListener('keypress', keyHandler, true);
            } 
            initMenu();

            // create ServiceManager with root services
            _sm = new DefaultServiceManager();
            _cf = new DefaultComponentFactory(_sm
                                             ,_log.getChildLogger("componentFactory")
                                             ,shortcutConfig
                                             );
            
            _sm.put("wobzilla.componentFactory"
                   ,_cf);
            _sm.put("wobzilla.popupFactory"
                   ,new DefaultPopupFactory(getEditWindow()));
            _sm.put("wobzilla.dialogFactory" 
                   , new DefaultDialogFactory(document.getElementById("dialog")
                                       ,keyHandler
                                       )
                   );
            _sm.put("wobzilla.selectionContext" 
                   ,new DefaultSelectionContext());
            _sm.put("wobzilla.serializer" 
                   ,new XMLSerializer());
            var parser = new Object();
            parser.parseString = WBZ_parseXML;
            _sm.put("wobzilla.parser" 
                   ,parser);
            _sm.put("wobzilla.xmlLoader"
                   ,_this);

            _log.info("wobzilla started");
        } catch (ex) {
            _log.error(ex);
        }
    }

    /** simulates a click in the demo menu*/
    this.demo = function(demoNr) {
        var event = new Object();
        event.target = new Object();
        event.target.id = "demo-" + demoNr;
        loadDemo(event);
    }

    this.load = function(filename)
    {
        //var xmlDocument = document.implementation.createDocument("", "test", null);
        //xmlDocument.load(filename,false);
        _log.info("Loading " + filename);
        var random = Math.round((Math.random()*10000000));
        var httpRequest = new XMLHttpRequest();
        httpRequest.open("GET", filename + "?wobzilla-random=" + random, false);
        httpRequest.setRequestHeader("Pragma","no-cache"); //doesn't work for mozilla cache
        try {
            httpRequest.send(null);
        } catch (ex) {
            throw new Error("Can't load " + filename + " " + ex);
        }
        var xmlDocument = httpRequest.responseXML;
        if (xmlDocument == null) {
            if (filename.substr(filename.length-4,4) != ".xml") {
                throw new Error("Filname '" + filename  + "' "
                                + " must end with '.xml'");

            }
            throw new Error("Can't process '" + filename  + "'. "
                            + "Make sure that the file is accessible.");
        }
        var errors = xmlDocument.getElementsByTagName("parsererror");
        if (errors.length>0) {
            throw new Error(errors[0].firstChild.nodeValue);
        }
        return xmlDocument;
    }


    function loadDemo(event) {
        try {
            var id = event.target.id;
            demo = id.substring(5);
            _log.debug("Demo " + _demos[demo].getAttribute("name") + " selected ");
            _this.viewFile = _demos[demo].getAttribute("view");
            _this.contentFile = _demos[demo].getAttribute("data");
            initDocument();
        } catch (ex) {
            _log.error(ex);
        }
    }


    function menuClick(evt) {
        var fileMenu = _fileMenu;
        fileMenu.style.visibility="visible";
        fileMenu.style.x="10" + "px";
        fileMenu.style.y="10" + "px";
        fileMenu.style.width="100" + "px";
        WBZ_info("file down");
    }

    function initMenu() {      
        var fileMenu = document.getElementById("file-menu");
        fileMenu.addEventListener("command",handleFileMenu,false);
        
        var demoMenu = document.getElementById("demo-popup");
        demoMenu.addEventListener("command",loadDemo,false);
        for (var i = 0; i < _demos.length; i++) {
            var menuItem = document.createElementNS(XUL_NS,"menuitem");
            menuItem.id = "demo-" + i;
            menuItem.setAttribute("label", _demos[i].getAttribute("name"));
            demoMenu.appendChild(menuItem);
        }

        var editMenu = document.getElementById("edit-popup");
        editMenu.addEventListener("command",handleEditMenu,false);
        
        var logVerbosity = document.getElementById("log-verbosity");
        logVerbosity.addEventListener("command"
                                      ,function(event) {
            var id = event.target.id;
            WBZ_setDebuggingLevel(id.substring(4));
        },false);
        document.getElementById("log-clear").addEventListener
            ("command",debugClear,false)
        document.getElementById("log-" + VERBOSE_LEVEL).setAttribute("checked","true");

        var outputSource = document.getElementById("output-source");
        outputSource.addEventListener("command",showOutputSource,false);
        
        var xpathProfile = document.getElementById("xpath-profile");
        xpathProfile.addEventListener("command",toggleXPathProfile,false);

    }

    /** handles undo key-events for edit-window. 
     */
    function keyHandler(event) {
        //log.info("" + event.charCode);
        if (event.altKey) {
            if (event.charCode == 122)
                _sm.lookup("wobzilla.transaction").undo(); 
            if (event.charCode == 121)
                _sm.lookup("wobzilla.transaction").redo(); 
        }
    }

    // clears debug output
    function debugClear() {
       var logDiv = document.getElementById('log_window');
       WBZ_removeAll(logDiv);
    }

    function initDocument() {
        var editDoc = getEditWindow().document;

        if ( _cf != null )
            _cf.disposeComponent( _rootView );
        
        var start = new Date();// Start counter

        // load document and view file
        var rootNode = 
            WBZ_getFirstElement(_this.load(_this.contentFile) );
        var rootConfig = 
            WBZ_getFirstElement(_this.load( _this.viewFile));
    
        // we need to move the loaded content to an invisible 
        // frame in the output document to make DOM-Events work.
        _xmlContent = getContentDocument();
        WBZ_removeAll( _xmlContent );
        rootNode.ownerDocument.removeChild( rootNode );
        _xmlContent.appendChild( rootNode );
        
        
        // create view for root-configuration (e.g. WbzMapper)
        _rootView = _sm.lookup("wobzilla.componentFactory").createComponent
            ( rootConfig
              ,_log.getChildLogger("root")
              ,_rootContext
              ,_sm);

        //Initialize Transaction-Handler with rootView and rootNode
        _sm.put("wobzilla.transaction"
               ,new DefaultTransactionHandler(rootNode
                                       ,_rootView
                                       ,_log.getChildLogger("undoHandler")
                                              ,document.getElementById("undo")
                                       ,document.getElementById("redo")
                                       )
               );


        try {
            // clear output
            if ( _container != null ) {
                WBZ_remove(editDoc.body, _container );
            } 
            _container = editDoc.createElementNS(HTML_NS,"div");
            
            // initialize rootView
            _rootView.init( _container, _xmlContent, null );
            editDoc.body.appendChild( _container );
        } catch (ex) {
            _container = null;
            throw ex;
        }
        
        //enable menu-items
        document.getElementById("reload").setAttribute("disabled","false");
        document.getElementById("save").setAttribute("disabled","false");
        document.getElementById("content-source").setAttribute("disabled","false");
        document.getElementById("view-source").setAttribute("disabled","false");


        _log.info("Content loaded. Took " 
                 + (new Date().getTime() - start.getTime()) + " ms");
    }

    function getEditWindow() {
        return document.getElementById('edit').contentWindow;
    }

    function getContentDocument() {
        return document.getElementById('content').contentWindow.document;
    }

    function getFormFrame() {
        return document.getElementById('form');
    }

    function handleFileMenu(event) {
        try {
            switch (event.target.id) {
            case "content-source": 
                _rootView.validate();
                showXmlSource( _xmlContent );
                break;
            case "view-source":
                showXmlSource( _this.load( _this.viewFile ) );
                //_log.info(WBZ_serializeXML(xml));
                break;
            case "reload":
                _log.info("reloading");
                initDocument();
                break;
            case "save":
                var valid = _rootView.validate();
                if (valid) {
                    _this.save( _this.contentFile, _xmlContent);
                } else {
                    _log.warn("Document not valid. Please check the error-texts!");
                }
                break;
            }
        } catch ( ex ) {
            _log.error( ex );
        }
    }


    /** we use forms instead of XMLHttpRequest here
        to allow file and image uploading in future version.
     */
    this.save = function( file, contentDocument) {
        var formDocument = getFormFrame().contentWindow.document;
        var form = document.createElementNS( HTML_NS, "form" );
        var resultFrame = document.createElementNS( HTML_NS, "iframe" );
        resultFrame.setAttribute( "name", "formResult" );
        resultFrame.setAttribute( "id", "formResult" );
        formDocument.body.appendChild(form);
        WBZ_removeAll(formDocument.body);
        formDocument.body.appendChild(form);
        formDocument.body.appendChild(resultFrame);

        form.action = "save_data.php";
        form.enctype="multipart/form-data";
        form.method="POST";
        form.target="formResult";
        _log.info("Saving " + file + ". Please wait!");
        var formArguments = document.createElementNS(HTML_NS,"div");
        form.appendChild(formArguments);
        WBZ_removeAll(formArguments);
        var args = new Array();
        args["filename"] = file;
        args["content"] = WBZ_serializeXML(contentDocument);
        //form.encoding = action;
        for (name in args) {
            var field = document.createElementNS(HTML_NS,"input");
            field.style.visibility = "hidden";
            field.name = name;
            field.value = args[name];
            formArguments.appendChild(field);
        }
        resultFrame.addEventListener("load",saved,true);

        //getFormFrame().style.display ="block";
        form.submit();
    }

    function saved() {
        try {
            var resultFrame = getFormFrame().contentWindow.document.getElementById("formResult").contentWindow;
            var form = resultFrame.document;
            //form.addEventListener("click",closeSaveStatus,true);
            var status = form.getElementById("status");
            if (status != null && status.firstChild.nodeValue == "ok") {
                _log.info("SAVED");
                //getFormFrame().style.visibility = "hidden";
            } else {
                _log.error(null,"error occured during saving!");
                var element = form.getElementById("error");
                if (element != null) {
                    var errorText = "";
                    var childs = element.childNodes;
                    for (var i=0;i<childs.length;i++) {
                        errorText += childs[i].nodeValue;
                    }
                    _log.error(null,errorText);
                }
            }
        } catch (ex) {
            _log.error(ex);
        }
    }
    
    function closeSaveStatus() {
        getFormFrame().style.display = "none";
    }

    function handleEditMenu(event) {
        switch (event.target.id) {
        case "undo":
            _sm.lookup("wobzilla.transaction").undo();
            break;
        case "redo":
            _sm.lookup("wobzilla.transaction").redo();
            break;
        }
    }

    function showOutputSource(event) {
        showXmlSource(getEditWindow().document);
    }

    function showXmlSource(xmlSource) {
        BX_xml_source = xmlSource;
        var BX_source_window = window.open("external/showsource/showsource.html"
                                           ,"_blank"
                                           ,"");
    }

    function profileEnabled() {
        return document.getElementById("xpath-profile").getAttribute("checked") == "true";
    }
    
    function toggleXPathProfile(event) {
        _rootContext.put("wobzilla_xpath_profile",profileEnabled() ? "true()" : "false()");
    }
   
}

/** 
 @implements wobzilla_selectionContext
 @constructor
 */
function DefaultSelectionContext() {
    var _listeners = new Array();

    this.addSelectionListener = function( selectionChangedMethod ) {
        _listeners.push( selectionChangedMethod );
    }

    this.select = function(target,args) {
        for (var i = 0; i < _listeners.length; i++ ) {
            _listeners[i]( target, args );
        }
    }
}


/** 
 @implements wobzilla_componentFactory
 @constructor
 */
function DefaultComponentFactory( _sm, _log, _shortcutConfig ) {
    var _shortcuts = createShortcuts( _shortcutConfig );

    /**
       @throws ClassNotFoundException
     */
    this.createComponent = function(componentConfig,logger,context,serviceManager) {
        if (serviceManager == null) {
            serviceManager = _sm;
        } 
        var config = componentConfig;
        var component;
        if (config.localName == "view") {
            var className = config.getAttribute("class");            
            if (className == null) {
                throw new Error("Attribute class not set on view component!");
            }
            try {
                var construct = "new " + className + "()";
                if (_log.debugging)
                    _log.debug("Creating: " + construct);
                component = eval(construct);
            } catch (ex) {
                classNotFound(ex,className);
            } 
        } else {
            component = createDefault(config.localName);
        }
        var id = config.getAttribute("id");
        if (logger!= null && id != null ) {
            if (_log.debugging) {
               _log.debug("Child Logger for " + id);
            }
            logger = logger.getChildLogger(id);
        }
        this.setup(component,config,logger,context,serviceManager);
        return component;
    }
    
    this.disposeComponent = function( component ) {
        if ( component != null && component.dispose ) {
            component.dispose();
        }
    }

    function classNotFound(ex,className) {
        throw new Error(ex + ". The cause can be a syntax error "
                        + "or that the javascript-file containing the component '" 
                        +  className + "' was not found. Check ScriptConsole!"
                        );
    }

    function createDefault(shortcut) {
        var constructor = _shortcuts[shortcut];
        if (constructor == null) {
            throw new Error("Can't find component for name " + shortcut);
        }
        return new constructor;
    }

    function createShortcuts(config) {
        var shortcuts = new Array();
        var configs = WBZ_getElements( config);
        for (var i=0;i<configs.length;i++) {
            var name = configs[i].getAttribute("name");
            var className = configs[i].getAttribute("class");
            try {
                shortcuts[name] = eval(className);
            } catch (ex) {
                classNotFound(ex,className);
            } 
        }
        return shortcuts;
    }
    
    this.setup = function( component, config, logger, context, serviceManager) {
        if (logger == null) {
            logger = _log;
        }
        if (component.enableLogging != null) {
            component.enableLogging(logger);
        }
        if (component.contextualize != null) {
            component.contextualize(context);
        }
        if (component.service != null) {
            component.service(serviceManager);
        }
        if (component.configure != null) {
            component.configure(config);
        }
        return component;
    }
}    

/** Default implementation of wobzilla.transaction
  @implements wobzilla_transaction
  @constructor
*/
function DefaultTransactionHandler(_rootNode, _rootView, _log, _undoButton, _redoButton) {
    var _activeTransaction = null;
    var _undoRedoActive = false;
    var _undoStack = new Array();
    var _redoStack = null;

    _rootNode.addEventListener("DOMNodeInserted",inserted,true);
    _rootNode.addEventListener("DOMNodeRemoved",removed,true);
    _rootNode.addEventListener("DOMAttrModified",attrModified,true);
    updateButtons();

    this.undo = function() {
        try{
            if ( _undoRedoActive )
                return;

            if ( _activeTransaction != null)
               throw new Error("There is already an active transaction!"); 
            
            var transaction = _undoStack.pop();
            if (transaction == null) {
                _log.warn("No further undos");
                return;
            }
            _log.info("Undo!");
            if ( _redoStack == null ) {
                _redoStack = new Array();
            }
            _redoStack.push(transaction);
            _undoRedoActive = true;
            this.execute(invertTransaction(transaction));
        } catch (ex) {
            _log.error(ex);
        } finally {
            _undoRedoActive = false;
        }
        updateButtons();
    }

    this.abort = function() {
        if ( _undoRedoActive )
          return;
        
        if ( _activeTransaction == null)
            throw new Error("There is no active transaction!"); 

        transaction = invertTransaction( _activeTransaction);
        _undoRedoActive = true;
        for (i=0;i<transaction.events.length;i++) {
            var atomar = transaction.events[i];
            processEvent(atomar);
        }
        _undoRedoActive = false;
    }

    this.redo = function() {
        try{
            if ( _undoRedoActive )
                return;

            if ( _activeTransaction != null)
               throw new Error("There is already an active transaction!");  

            if ( _redoStack == null || _redoStack.length == 0) {
                _log.warn("No further redos");
                return;
            }
            _log.info("Redo!");
            var transaction = _redoStack.pop();
            _undoStack.push(transaction);
            _undoRedoActive = true;
            this.execute(transaction);
        } catch (ex) {
            _log.error(ex);
        } finally {
            _undoRedoActive = false;
        }
        updateButtons();
    }

    this.start = function() {
        if ( _undoRedoActive )
           return;

        if ( _activeTransaction != null) {
            throw new Error("There is already an active transaction!");
        }

        _activeTransaction = new Object();
        _activeTransaction.events = new Array();
        _undoStack.push( _activeTransaction);
    }
    
    this.commit = function() {
        if ( _undoRedoActive )
           return;

        if ( _activeTransaction == null) {
            throw new Error("There is no active transaction!");
        }
        try {
            _rootView.requery( _activeTransaction );
        } catch (ex) {
            this.abort();
            _undoStack.pop();
            _log.error(ex);
            throw new Error("GUI Refresh failed. GUI maybe invalid.");
        } finally {
            _activeTransaction = null;
        }
        updateButtons();
    }

    this.execute = function(transaction) {
        for (i=0;i<transaction.events.length;i++) {
            var atomar = transaction.events[i];
            processEvent(atomar);
        }
        _rootView.requery(transaction);
    }


    function updateButtons() {
        _undoButton.setAttribute("disabled", _undoStack.length > 0 ? "false" : true);
        _redoButton.setAttribute("disabled", ( _redoStack != null 
                                             && _redoStack.length > 0)? "false" : true);
    }

    function inserted(event) {
        if ( _log.debugging )
            _log.debug(event.target.nodeName + " inserting into " 
                      + event.relatedNode.nodeName);
        pushEvent(event);
    }

    function removed(event) {
        if ( _log.debugging )
            _log.debug(event.target.nodeName + " removing from " 
                      + event.relatedNode.nodeName);
        
        pushEvent(event);
    }

    function attrModified(event) {
        if ( _log.debugging )
            _log.debug(event.target.nodeName + "@" + event.attrName 
                      + " set to " + event.newValue);
        pushEvent(event);
    }

    function cloneEvent(event) {
        var clone = new Object();
        clone.target = event.target;
        clone.type = event.type;
        clone.attrName = event.attrName;
        clone.newValue = event.newValue;
        clone.prevValue = event.prevValue;
        clone.relatedNode = event.relatedNode;
        clone.insertPos = event.insertPos;
        return clone;
    }

    function pushEvent(event) {
        if ( _undoRedoActive )
            return;

        _redoStack = null;
        if ( _activeTransaction == null) {
            throw new Error("atomar commands are not supported. Must start transaction.");
        }

        var newEvent = cloneEvent(event);
        newEvent.insertPos = event.target.nextSibling;
        _activeTransaction.events.push(newEvent);
        assertNotNull(event.target);
        if ( _activeTransaction.target == null 
            || WBZ_isAncestorOf(event.target, _activeTransaction.target )
            ) 
        {
            _activeTransaction.target = event.target;
        }
        updateButtons();
        return newEvent;
    }

    function processEvent(e) {
        switch (e.type) {
            case "DOMAttrModified":
                e.target.setAttribute(e.attrName,e.newValue);
                return;
            case "DOMNodeRemoved":
                e.relatedNode.removeChild(e.target);
                return;
            case "DOMNodeInserted":
                e.relatedNode.insertBefore(e.target,e.insertPos);
                return;
        default:
            throw new Error(" Event type " + e.type + " not supported ");
        }
    }        

    function invertTransaction(transaction) {
        var inverted = new Object();
        inverted.target = transaction.target;
        inverted.events = new Array();
        
        // add events in inverted order
        var length =  transaction.events.length;
        for (var i=0;i<length;i++) {
            var invertedEvent = invertEvent(transaction.events[i]);
            inverted.events[length -i -1] = invertedEvent;
        }
        return inverted;
    }

    function invertEvent(event) {
        var newEvent = cloneEvent(event);
        switch (event.type) {
            case "DOMAttrModified":
                newEvent.newValue = event.prevValue;
                newEvent.prevValue = event.newValue;
                return newEvent;
            case "DOMNodeRemoved":
                newEvent.type = "DOMNodeInserted";
                return newEvent;
            case "DOMNodeInserted":
                newEvent.type = "DOMNodeRemoved";
                return newEvent;
        default:
            throw new Error(" Event type " + e.type + " not supported ");
        }
    }
}

/**
   @implements wobzilla_dialogFactory 
   @constructor
*/
function DefaultDialogFactory(_dialogFrame,_defaultKeyHandler) {
    var _oldFile = null; // we cache the oldFile
    var _closeMethod;
    var _openMethod;
    var _dialogContentWindow;
    var _titleTextNode;
    var _frameElement;

    this.createDialog = function (dialogFile,titleText,openMethod,closeMethod,left,top,width,height) {
        _dialogFrame.style.display="block";
        _closeMethod = closeMethod;
        _openMethod = openMethod;
        _dialogFrame.setAttribute("left", left);
        _dialogFrame.setAttribute("top", top);
        _dialogFrame.setAttribute("width",width);
        _dialogFrame.setAttribute("height",height);
        if (dialogFile != _oldFile) {
            var dialogWindow = _dialogFrame.contentWindow;
            var dialogDoc = dialogWindow.document;
            var body = dialogDoc.body;
            // clear output
            WBZ_removeAll(body);
            var closeButton = document.createElementNS(HTML_NS,"button"); 
            var img = document.createElementNS(HTML_NS,"img");
            img.setAttribute("src","images/close.gif");
            closeButton.appendChild(img);
            closeButton.setAttribute("class","smallButton");
            closeButton.addEventListener("click",close,true);
            var title = document.createElementNS(HTML_NS,"span");
            title.setAttribute("class","dialogTitle");
            _titleTextNode = document.createTextNode("");
            title.appendChild(_titleTextNode);
            
            _frameElement = document.createElementNS(HTML_NS,"iframe"); 
            _frameElement.style.margin="0px";
            _frameElement.setAttribute("srolling","no");
            _frameElement.setAttribute("width",width-6);
            _frameElement.setAttribute("height",height-30);

            body.style.margin="0px";
            body.appendChild(closeButton);
            body.appendChild(title);
            body.appendChild(_frameElement);
            _dialogContentWindow = dialogWindow.frames[dialogWindow.frames.length-1];
            _dialogContentWindow.onload = dialogLoaded;
            _dialogContentWindow.location = dialogFile;

            _dialogContentWindow.addEventListener('keypress', keyHandler, true);
            _oldFile = dialogFile;
        } else {
            _frameElement.setAttribute("width",width-6);
            _frameElement.setAttribute("height",height-30);
            _dialogFrame.style.visibility="visible";
            _openMethod(_dialogContentWindow);
        }
        _titleTextNode.nodeValue = titleText;
    }

    this.closeDialog = function(dialog) {
        close();
    }

    function dialogLoaded() {
        var frames = _dialogContentWindow.frames;
        for (var f = 0; f < frames.length; f++) {
            frames[f].document.addEventListener('keypress', keyHandler, true);
        } 
        _dialogFrame.style.visibility="visible";
        _openMethod( _dialogContentWindow );
    }
    
    function close() {
        _dialogFrame.style.visibility="hidden";
        _dialogFrame.style.display="none";
        _closeMethod();
    }

    // handles key-events for dialog-window. 
    function keyHandler(event) {
        _defaultKeyHandler(event);
        if (event.altKey) {
            if (event.charCode == 120) {
                close();                
            }
        }
    }
}

var POPUP_FACTORY_IDS = 0;
/** 
 @implements wobzilla_popupFactory 
 @constructor
*/
function DefaultPopupFactory(editWindow) {
    var win = editWindow;
    var editDoc = editWindow.document;
    var html = editDoc.body;
    var popup = editDoc.createElementNS(HTML_NS,"div");
    var mouseX;
    var mouseY;

    html.addEventListener("click",myhidepopup,true);
    html.addEventListener("contextmenu",myhidepopup,true);
    html.addEventListener("keypress",myhidepopup,true);
    html.addEventListener("mousemove",onmousemove,true);

    popup.id = "WBZ_POPUP" + (POPUP_FACTORY_IDS ++);
    popup.setAttribute("style","visibility: hidden; top: 150px; height: 50px; width: 100px; position: fixed; background-color: #a0a0a0; z-index: 20;");
    html.appendChild(popup);

    this.showPopup = function(htmlMenu,x,y) {
        createPopup(htmlMenu,0,0,win);

        // adjust to window size
        if ((popup.offsetTop + popup.offsetHeight) > win.innerHeight)
        {
            popup.style.top = win.innerHeight - popup.offsetHeight- 10 +"px";
        }
        popup.style.visibility = "visible";
        popup.style.top= popup.offsetTop - 1 + "px";
    }


    this.hidePopup = function() {
        popup.style.top = win.innerHeight + "px";
        popup.style.visibility = "hidden";
    }

    function myhidepopup(event) {
        try {
            if (event.target != popup && popup.style.visibility != "hidden") {
                popup.style.top = win.innerHeight + "px";
                popup.style.visibility = "hidden";
            }
        } catch (ex) {
            logError(ex);
        }
    }


    function onmousemove(event) {
        mouseX = event.pageX;
        mouseY = event.pageY;
    }

    function createPopup(htmlNode,width,height,win)
    {
        popup.style.visibility = "hidden";

        // Set popup- position relative to mouse pointer
        popup.style.top = mouseY - win.pageYOffset + "px";
        popup.style.left = mouseX - win.pageXOffset + "px";
        if (height == 0)
        {
            popup.style.height = "";
        }
        else
        {
            popup.style.height = height + "px";
        }
        if (width == 0)
        {
            popup.style.width = "";
        }
        else
        {
            popup.style.width = width;
        }
        var nodes = WBZ_getChilds(popup);
        for (var i=0;i<nodes.length;i++) {
            popup.removeChild(nodes[i]);
        }
        popup.appendChild(htmlNode);
    }
}
 
