<?xml version="1.0"?>

<!--                                                                                -->
<!--  Default XSL stylesheet for use by com.lotus.xsl.server#DefaultapplyXSL.       -->
<!--                                                                                -->
<!--  This stylesheet mimics the default behavior of IE when XML data is displayed  -->
<!--  without a corresponding XSL stylesheet.  This stylesheet uses JavaScript      -->
<!--  to accommodate node expansion and contraction.                                -->
<!--                                                                                -->


<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns="http://www.w3.org/1999/xhtml"
>
               
<xsl:output method="html" indent="no"/>
<xsl:strip-space elements="*"/>

<xsl:template match="/">
    <div id="st"><xsl:apply-templates/></div>

</xsl:template>

<!-- Templates for each node type follows.  The output of each template has a similar structure
  to enable script to walk the result tree easily for handling user interaction. -->
  
<!-- Template for pis not handled elsewhere -->
<xsl:template match="processing-instruction()">
  <div id="e">
  <span id="b">&#160;</span>
  <span id="m">&lt;?</span><span id="pi"><xsl:value-of select="name(.)"/>&#160; <xsl:value-of select="."/></span><span id="m">?&gt;</span>
  </div>
</xsl:template>

<!-- Template for attributes not handled elsewhere -->
<xsl:template match="@*"><span id="t"><xsl:text> </xsl:text><xsl:value-of select="name(.)"/></span><span id="m">="</span><B><xsl:value-of select="."/></B><span id="m">"</span></xsl:template>

<!-- Template for text nodes -->
<xsl:template match="text()">
  <xsl:choose><xsl:when test="name(.) = '#cdata-section'"><xsl:call-template name="cdata"/></xsl:when>
  <xsl:otherwise><div id="e">
  <span id="b">&#160;</span>
  <span id="tx"><xsl:value-of select="."/></span>
  </div></xsl:otherwise></xsl:choose>
</xsl:template>


<!-- Template for comment nodes -->
<xsl:template match="comment()">
  <div id="k">
  <span><a id="b" onclick="return false" onfocus="h()" style="visibility:hidden">-</a> <span id="m">&lt;!--</span></span>
  <span id="clean" class="ci"><PRE><xsl:value-of select="."/></PRE></span>
  <span id="b">&#160;</span> <span id="m">--&gt;</span>
  <script>f(clean);</script></div>
</xsl:template>
<!-- Template for cdata nodes -->
<xsl:template name="cdata">
  <div id="k">
  <span><a id="b" onclick="return false" onfocus="h()" style="visibility:hidden">-</a> <span id="m">&lt;![CDaTa[</span></span>
  <span id="clean" class="di"><PRE><xsl:value-of select="."/></PRE></span>
  <span id="b">&#160;</span> <span id="m">]]&gt;</span>
  <script>f(clean);</script>
  </div>
</xsl:template>

<!-- Template for elements not handled elsewhere (leaf nodes) -->
<xsl:template match="*">
  <div id="e"><div style="margin-left:1em;text-indent:-2em">
  <span id="b">&#160;</span>
  <span id="m">&lt;</span><span id="t"><xsl:value-of select="name(.)"/></span> <xsl:apply-templates select="@*"/><span id="m"> /&gt;</span>
  </div></div>
</xsl:template>

<!-- Template for elements with only text children -->
<xsl:template match="*[text() and not(comment() or processing-instruction() or *)]">
  <div id="e"><div style="margin-left:1em;text-indent:-2em">
  <span id="b">&#160;</span> <span id="m">&lt;</span><span id="t"><xsl:value-of select="name(.)"/></span><xsl:apply-templates select="@*"/>
  <span id="m">&gt;</span><span id="tx"><xsl:value-of select="."/></span><span id="m">&lt;/</span><span id="t"><xsl:value-of select="name(.)"/></span><span id="m">&gt;</span>
  </div></div>
</xsl:template>

<xsl:template match="*[*]">
  <div id="e">
  <div id="c" style="margin-left:1em;text-indent:-2em"><a href="#" onclick="return false" onfocus="h()" id="b">-</a> <span id="m">&lt;</span><span id="t"><xsl:value-of select="name(.)"/>
  </span><xsl:apply-templates select="@*"/><span id="m">&gt;</span></div>
  <div><xsl:apply-templates/>
  <div><span id="b">&#160;</span><span id="m">&lt;/</span><span id="t"><xsl:value-of select="name(.)"/></span><span id="m">&gt;</span></div>
  </div></div>
</xsl:template>


</xsl:stylesheet>
