/** HTMLField is using mozile editor. Undo functionality
not implemented and there are some issues with focus.
*/
function WbzHTMLField() {
    var _sm;
    var _context;

    var _model;
    var _xpath;
    var _outputNode;
    var _resolver;

    this.contextualize = function(context) {
        _context = context;
    }

    this.service = function(serviceManager) {
        _sm = serviceManager;
        _resolver = _sm.lookup("wobzilla.xpath");
    }

    this.configure = function(config) {
        _xpath = config.getAttribute("select");
    }

    this.init = function(parentOutputNode,parentModelNode,insertAfter) {
        _outputNode = document.createElementNS(HTML_NS,"div");
        _outputNode.setAttribute("class","input");
        WBZ_insertAfter(parentOutputNode,_outputNode,insertAfter);
        insertAfter = _outputNode;
        _model = _resolver.getNodeSafe(parentModelNode, _xpath, _context);
        _outputNode.setAttribute("contentEditable",true);

        var nodes = _model.childNodes;
        for (var i=0;i<nodes.length;i++) {
            this.addElement(_outputNode,nodes[i]);
        }
        return insertAfter;
    }

    this.addElement = function(outputNode,model) {
        var newChild = model.cloneNode(false);
        outputNode.appendChild(newChild);
        var nodes = model.childNodes;
        for (var i=0;i<nodes.length;i++) {
           this.addElement(newChild,nodes[i]);
        }
    }

    this.requery = function(changes) {
    }

    this.validate = function() {
        _sm.lookup("wobzilla.transaction").start();        
        WBZ_removeAll(_model);
        var nodes = _outputNode.childNodes;
        for (i=0;i<nodes.length;i++) {
            _model.appendChild(nodes[i].cloneNode(true));
        }
        _sm.lookup("wobzilla.transaction").commit();        
    }
}

/** Uses Mozilla Composer Component in internal window, not yet implemented */
function WbzComposerField() {
    this.init = function(parentOutputNode,parentModelNode,insertAfter) {
        throw new Error("Not yet implemented");
    }
}

