/** 
   <p> 
    <code>WbzContainer</code> allows the embedding <em>views</em>
    into an host language lile <em>HTML</em> or <em>XUL</em>. There is
    no equivalent in XSLT. In XSLT these elements can be written in
    the so called <em>template-bodies</em> under the most elements (see
    <a href="http://www.w3.org/TR/xslt">XSLT-specification</a>).
    Wobzilla can also use this notation, by transparently wrapping
    those elements under an <code>WbzContainer</code> see below.
   </p>

   <h2>Embedding of components into a host-language</h2>   
   <p>
     Enables the use of templates in Wobzilla. The following examples 
     shows the embedding into a HTML-Table:
     </p>
 <pre>
&lt;wbz:container>
 &lt;html:table>
  &lt;html:tr>
   &lt;html:td>firstname:&lt;/html:td>
   &lt;html:td>&lt;wbz:value-of select="&#64;firstname"/>&lt;/html:td>
  &lt;/html:tr>
  &lt;html:tr>
   &lt;html:td>Lastname:&lt;/html:td>
   &lt;html:td>&lt;wbz:value-of select="&#64;lastname"/>&lt;/html:td>
  &lt;/html:tr>
 &lt;/html:table>
&lt;/wbz:container>
</pre> 

  <h2>Aggregation of multiple <em>views</em></h2>   
    <p>
     <code>WbzContainer</code> kann dazu verwendet werden, um mehrere
     <em>views</em> zusammenzupacken. Das macht die
     Verarbeitung von <em>views</em> fr andere Komponenten einfacher. Diese
     mssen jetzt statt mehrerer views nur einen Container als
     Unter-<em>view</em> verwalten. Den Komponenten steht es frei, einen
     wbz:container automatisch zu erzeugen, falls mehr als eine <em>view</em>-Konfiguration
	 oder ein Element, das nicht zum wbz:name-space
     gehrt, gefunden werden. Die von Wobzilla bereitgestellten
     Basis-Komponenten nehmen diese Ersetzung automatisch vor, um die
     Verwendung fr den Ersteller des Stylesheets transparent zu
     halten. So kann die gewohnte XSLT-Schreibweise ohne
     Container-Anweisung verwendet werden. In den Beispielen in diesem
     und im nchsten Kapitel wird aber die Container-Schreibweise
     beibehalten, da sie das Zusammenspiel der einzelnen Komponenten
     verdeutlicht.
    </p>

  <h2>Use of local variables</h2>   
    <p>
     Variablen-Anweisungen mssen immer am Anfang des Containers
     stehen. Findet der <em>container</em> eine <code>variable</code>
     Anweisung, dann erzeugt er einen entsprechenden <em>view</em>
     (<code>WbzValueOf</code>), initialisiert diesen aber nicht mit
     einem Knoten aus dem Ausgabebaum, sondern einem
     leeren Knoten ohne Vaterelemente. <code>WbzValueOf</code>
     schreibt in diesen Knoten dann den Variableninhalt. Danach
     wird der Inhalt der Variablen im Kontextobjekt
     <code>wobzilla.local</code> unter dem Namen, der im
     <code>name</code>-Attribut angegeben wurde, abgelegt. Alle
     folgenden Unterviews werden nun mit dem vernderten Unterkontext
     initialisiert.
    </p>
    <p>
     Wird die <code>requery</code>-Methode des Containers aufgerufen, dann
     werden zuerst die requery-Methoden der Variablen aufgerufen. Wenn
     mindestens eine Variable den Inhalt des ihr zugeordneten
     Textknotens verndert, mssen alle anderen Unterkomponenten
     neu erzeugt werden, weil sich deren Kontext gendert hat.
    </p>

  @requires wobzilla_xpath
  @requires wobzilla_variableFactory
  @requires wobzilla_componentFactory
  @constructor
*/
function WbzContainer() {
    function dummy();
}

