/** 
<code>WbzRepeat</code> is a very powerful component, although its only consists of a few hundred lines of code. It allows editing of a number of elements
in different display formats.

   <p><strong>attributes:</strong></p>
   <table>
     <thead>
       <th>attribute</th><th>type</th><th>description</th>
     </thead>
     <tbody>
      <tr><td><strong>select</strong></td><td><code>expression</code></td><td>the <em>XPath</em>-expression matching all elements that should be displayed in the <em>repeat</em>. 
      Elements of different type can also be selected e.g. <code>bookmark|folder</code>. 
      But only <code>direct childs</code> of the context-node can be selected.</td></tr>

      <tr><td><strong>insertAt</strong></td><td><code>expression</code></td>
      <td>describes the node-set after which a new node should be inserted,
      if there is no matched node. If there is already a matched node,
      the new nodes are inserted at the end of the list.
      If theres a sort entry, the new nodes will be inserted
      at the appropriate position.</td></tr>

      <tr><td><strong>type</strong><br/>optional</td><td>table | free</td><td>manner, in which the entries should be arranged, default is
      free.</td></tr>
      <tr><td><strong>cssClass</strong><br/>optional</td><td><code>QName</code></td><td>name
      of the <em>css-rule</em>, that should be used when rendering the
      repeat-container (not the contained elements), default is <code>repeat</code>.</td></tr>
      <tr><td><strong>collapsable</strong><br/>optional</td><td><code>boolean</code></td><td>This flag determines whether there is an additional switch that can 
      be used to hide and unhide the list. One can achieve a tree-like component
      when using this in combination with nested repeats. (See the bookmarks example)
     </td></tr>
    </tbody>
   </table>
   <p><strong>child elements:</strong></p>
   <table>
    <thead>
     <th>configuration</th><th>count</th><th>description</th>
    </thead>
    <tbody>
     <tr><td><strong>sort</strong></td><td>0-*</td><td>analog to the <em>sort</em> in XSLT.</td></tr>
     <tr><td><strong>create</strong></td><td>1-*</td><td>describes the elements, 
that could be inserted into the liste. A new <em>button</em> will be created for every <code>create</code>-instruction. The label of this button can be set with the <code>label</code>-attribute. The content of this element contains a prototype of the element that should be created, e.g. <code>&lt;person name=''/></code>.
</td></tr>
     <tr><td><strong>thead</strong></td><td>0-1</td><td>in table-mode it is possible to define a table-header (same as in html:thead).</td></tr>
     <tr><td><strong>dialog</strong></td><td>0-1</td><td>Allows the configuration of an
     additional dialog edit-view for the selected entry.</td></tr>
     <tr><td><strong>view configuration</strong></td><td>0-1</td><td>a new <em>view</em> is 
     created for every matched entry.</td></tr>
    </tbody>
   </table>
<p>
  <strong>Validation</strong> is done after the creation, removal or the move of
  an entry.
</p>
<p>
   <a href="../repeat-configs.html">See a list of config examples</a>:
</p>

  @requires wobzilla_transaction
  @requires wobzilla_componentFactory
  @requires wobzilla_sortFactory
  @requires wobzilla_xpath
  @requires wobzilla_selectionContext

  @constructor
*/
function WbzRepeat() {
    function dummy();
}
