var WbzRepeat_de = new Object();
WbzRepeat_de["edit"] = "bearbeiten";
WbzRepeat_de["remove"] = "entfernen";
WbzRepeat_de["move up"] = "nach oben";
WbzRepeat_de["move down"] = "nach unten";

var WbzRepeat_en = new Object();
WbzRepeat_en["edit"]="edit" ;
WbzRepeat_en["remove"]="remove";
WbzRepeat_en["move up"]="move up";
WbzRepeat_en["move down"]="move down";

function WbzRepeat() {
    var _log;
    var _sm; //the serviceManager
    var _cf;
    var _context;
    var _cutDisabled;

    var _resolver;
    var _xpath;
    var _parentModel;
    var _outputNode;
    var _entries = new Array();

    var _viewConfig;
    var _createConfigs = new Array();
    var _removeButton;
    var _editButton;
    var _insertXPath;

    var _selectedEntry = null;
    var _previousEntry;
    var _nextEntry;
    var _selectionContext;

    var _editDialog = null;

    var _sortHandler;

    var _collapsable;
    var _folder;
    var _foldedNode;
    var _containerNode;

    var _table;
    var _tableHeader;

    var _loc = WbzRepeat_en;

    var _this = this;


    this.enableLogging = function(logger) {
        _log = logger;
    }

    this.service = function(serviceManager) {
        _sm = serviceManager;
        _resolver = _sm.lookup("wobzilla.xpath");
        _cf = _sm.lookup("wobzilla.componentFactory");
    }

    this.contextualize = function( context ) {
        _context = context;
        _cutDisabled = _context.get("wobzilla.defaultCut") != true;
    }

    this.configure = function(config) {
        _insertXPath = WBZ_attribute( config, "insertAt", null );
        _xpath = WBZ_attribute( config, "select", ".");
        _collapsable = WBZ_attribute( config, "collapsable", "true");
        _table = config.getAttribute("type") == "table";
        var childs = config.childNodes;
        var configNodes = new Array();
        var sortConfigs;
        for (var i =0 ;i<childs.length;i++) {
            if (childs[i].namespaceURI == WOBZILLA_NS) {
                if (childs[i].localName == "create") {
                    _createConfigs.push(childs[i]);
                    continue;
                } else if (childs[i].localName == "sort") {
                    if (sortConfigs == null)
                        sortConfigs = new Array();
                    sortConfigs.push(childs[i]);
                    continue;
                } else if (childs[i].localName == "dialog") {
                    _editDialog = new EditDialog();
                    _editDialog.configure(childs[i]);
                    continue;
                } else if (childs[i].localName == "thead") {
                    _tableHeader = WBZ_getFirstElement(childs[i]);
                    if ( _tableHeader != null )
                        _tableHeader = _tableHeader.cloneNode(true);
                    continue;
                } 
            }
            configNodes.push(childs[i]);
        }
        if ( sortConfigs != null ) {
            var fact = _sm.lookup("wobzilla.sortFactory");
            _sortHandler = fact.createSortHandler(sortConfigs, _log, _context, _sm);
        }
        
        _viewConfig = WBZ_wrapChildConfigs(configNodes);
        _selectionContext = _sm.lookup("wobzilla.selectionContext");
        _selectionContext.addSelectionListener( selectionChanged );
    }    

    this.init = function( outputNode, parentModel, insertAfter ) {
        _parentModel = parentModel;
        var mainContainerNode = document.createElementNS( HTML_NS, "div" );
        WBZ_insertAfter( outputNode, mainContainerNode, insertAfter );
        if ( _table ) {
            _outputNode = document.createElementNS( HTML_NS, "table" );
            _outputNode.setAttribute( "class", "repeatContentTable" );
        } else {
            _outputNode = document.createElementNS( HTML_NS, "div" );
            _outputNode.setAttribute( "class", "repeatContent" );
        }
        // init first node in output
        if ( _tableHeader != null ) {
            _outputNode.appendChild( _tableHeader);
        } else {
            _outputNode.appendChild( document.createTextNode("") );
        }
        var buttonPanel = document.createElementNS( HTML_NS, "span" );
        buttonPanel.setAttribute( "class", "repeatButtonPanel" );

        if ( _collapsable == "true") {
            _folder = document.createElementNS(HTML_NS,"span");
            _folder.appendChild(document.createTextNode("-"));
            _folder.setAttribute("class","repeatFolder");
            mainContainerNode.appendChild( _folder );
            _folder.addEventListener("click", foldElement, true);
        }

        _containerNode = document.createElementNS(HTML_NS,"div");
        _containerNode.appendChild(buttonPanel);
        _containerNode.appendChild(_outputNode);
        _containerNode.setAttribute("class","repeat");

        mainContainerNode.appendChild( _containerNode );
        _foldedNode = document.createElementNS(HTML_NS,"div");
        _foldedNode.appendChild(document.createTextNode("..."));
        _foldedNode.style.display="none";
        mainContainerNode.appendChild(_foldedNode);

        insertAfter = mainContainerNode;
        for (var i = 0; i < _createConfigs.length; i++ ) {
            var label = _createConfigs[i].getAttribute("label");
            var button = createButton(label,"images/new.gif");
            buttonPanel.appendChild(button);
            button.addEventListener("click"
                                    ,new Action(newChildElement,i).action
                                    ,false);
        }
        if ( _editDialog != null ) {
            _editButton = createButton(_loc["edit"],"images/edit.gif");
            _editButton.addEventListener("click",editChild,false);
            buttonPanel.appendChild(_editButton);
            enableButton(_editButton, false);
        }
            
        _removeButton = createButton(_loc["remove"],"images/remove.png");
        _removeButton.addEventListener("click",removeChild,false)
        enableButton(_removeButton, false);
        buttonPanel.appendChild(_removeButton);

        var modelNodes = _resolver.getNodes(_parentModel,_xpath,_context);

        for (var i = 0; i < modelNodes.length; i++ ) {
            //_log.debug("REPEATING: " + modelNodes[i].nodeName);
            _entries.push(createEntry(modelNodes[i],null, i + 1, modelNodes.length));
        }
        if ( _sortHandler != null ) {
            _sortHandler.sort(_entries, relocate);
        }
        initEntries();
        return insertAfter;
    }
    
    // validates the child views
    this.validate = function() {
        for ( var i = 0; i < _entries.length; i++ ) {
            _entries[i].view.validate();
        }
        if ( _editDialog != null && _editDialog.view != null ) {
            _editDialog.view.validate();
        }
    }

    function selectionChanged(target,args) {
        var newEntry = args;
        var notSelectedClass = _table ? "repeatNotSelectedTr" : "repeatNotSelected";
        var selectedClass = _table ? "repeatSelectedTr" : "repeatSelected";
        if ( target == _this && newEntry != null ) {
            if ( _selectedEntry != null && newEntry != _selectedEntry ) {
                _selectedEntry.outputStart.setAttribute("class", notSelectedClass);
            }
            _selectedEntry = newEntry;
            enableButton(_removeButton,true);
            enableButton(_editButton,true);
            if ( _selectedEntry.outputStart.getAttribute("class") != selectedClass) 
            {
                _selectedEntry.outputStart.setAttribute("class", selectedClass);
                if ( _editDialog != null ) {
                    _editDialog.setModel( _selectedEntry.model ); 
                }
            }
        } else {
            if ( _selectedEntry != null) {
                _selectedEntry.outputStart.setAttribute("class", notSelectedClass);
            }
            _selectedEntry = null;
        }

        // if nothing is selected
        if ( _selectedEntry == null ) {
            enableButton( _removeButton, false);
            enableButton( _editButton, false);

            if ( _editDialog != null) {
                _editDialog.close();
            }
        }

        updateNavigate();
    }

    function updateNavigate() {
        _nextEntry = null;
        _previousEntry = null;

        if ( _selectedEntry == null ) {
            return;
        }
        var nextElement = WBZ_nextElementSibling( _selectedEntry.outputStart); 
        var previousElement = WBZ_previousElementSibling( _selectedEntry.outputStart); 
        for (var i=0;i<_entries.length;i++) {
            if (nextElement != null && nextElement.isSameNode(_entries[i].outputStart))
                _nextEntry = _entries[i];
            if (previousElement != null && previousElement.isSameNode(_entries[i].outputStart))
                _previousEntry = _entries[i];
        }
        if ( _editDialog != null) {
            _editDialog.updateNavigate();
        }
    }

    this.dispose = function() {
        for (var i=0;i<_entries.length;i++) {
            _cf.disposeComponent(_entries[i].view);
        }
        if ( _editDialog != null) {
            _editDialog.close();
        }
        //delete this;
    }

    function foldElement() {
        var visibility = _outputNode.style.visibility;
        if ( _containerNode.style.display == "none" ) {
            _containerNode.style.display = "block";
            _folder.firstChild.nodeValue = "-";
            _foldedNode.style.display = "none";
            _folder.setAttribute("class","repeatFolder");
        } else {
            _containerNode.style.display = "none";
            _folder.firstChild.nodeValue = "+";
            _foldedNode.style.display = "block";
            _folder.setAttribute("class","repeatFolderCollapsed");
        }
    }

    function equalsModel_Entry(model,entry) {
        return model.isSameNode(entry.model);
    }

    this.requery = function(changes) {
        var newModel = _resolver.getNodes(_parentModel, _xpath, _context);
        var modelChanged = !WBZ_equals(newModel,_entries,equalsModel_Entry);
        if (modelChanged) {
            var inserted = new Array();
            var removed = new Array();
            WBZ_diff(newModel,_entries,inserted,removed,equalsModel_Entry);
            for (var i=0;i<removed.length;i++) {
                removeEntry(removed[i]);
                //_log.info(i + ") removed: " + removed[i].model.getAttribute("name"));
                removed[i].model = null;
            }

            var newEntries = new Array();
            var oldEntryIndex = 0;
            var insertIndex = 0;
            var lastOutput = _outputNode.firstChild;
            for (var i=0;i<newModel.length;i++) {
                var model = newModel[i];
                if (insertIndex <= inserted.length 
                    && model.isSameNode(inserted[insertIndex]))
                {
                    //_log.info(i + ") Inserted: " + model.getAttribute("name"));
                    var newEntry = createEntry(newModel[i]
                                               , lastOutput
                                               , newEntries.length + 1
                                               , newModel.length
                                               );
                    newEntries.push(newEntry);
                    lastOutput = newEntry.outputStart;
                    insertIndex ++;
                    continue;
                } else if ( _entries.length > 0 ) {
                    while ( true ) {
                        var entry = _entries[oldEntryIndex];
                        oldEntryIndex++;
                        if ( entry.model == null ) //deleted
                            continue;
                        if ( model.isSameNode( entry.model ) ) {
                            newEntries.push( entry );
                            lastOutput = entry.outputStart;
                            break;
                        } 
                    }
                }
            }
            _entries = newEntries;
        }

        var positionChanged = false;
        if ( _sortHandler != null ) {
            positionChanged = _sortHandler.sort( _entries, relocate );
        } 
        if ( modelChanged ) {
            initEntries();
        }
        if ( positionChanged ) {
            changes = WBZ_clone( changes );
            changes.positionChanged = positionChanged;
            updateNavigate();
        }
        for (var i=0;i<_entries.length;i++) {
            if ( _cutDisabled || WBZ_isTargeted( changes, _entries[i].model) ) {
                _entries[i].view.requery(changes);
            }
        }
        if ( _editDialog != null && _editDialog.view != null)
        {
            if ( _cutDisabled || WBZ_isTargeted( changes , _selectedEntry.model) ) {
                _editDialog.view.requery(changes);
            }
        }
    }

    /** relocate method for sorting*/
    function relocate( entry ) {
        //_log.info("relocate " + WBZ_serializeXML(entry.model))
        var following = entry.nextEntry;
        var lastNode =  (following != null) ? following.outputStart : null;
        _outputNode.removeChild( entry.outputStart );
        WBZ_insertBefore( _outputNode, entry.outputStart, lastNode);
    }

    function createMenu(text,graphic,method) {
        var menu = document.createElementNS(HTML_NS,"div");
        var button = createButton(text,graphic);
        button.addEventListener("click",method,true);
        menu.appendChild(button);
        return menu;
    }

    function contextmenu(event,args) {
        try {
            select(event,args);
            var contextEntry = args;
            var elementName = contextEntry.model.nodeName;
            var popup = document.createElementNS(HTML_NS,"div");

            if ( _editDialog != null ) {
                popup.appendChild(createMenu(_loc["edit"],"images/edit.gif",editChild));
            }

            for (var i = 0; i < _createConfigs.length; i++) {
                var label = _createConfigs[i].getAttribute("label");
                popup.appendChild(createMenu(label,"images/new.gif",
                                             new Action(newChildElement,i).action
                                             )
                                  );
            }

            popup.appendChild(createMenu(_loc["remove"],"images/remove.png",removeChild));
            if ( _sortHandler == null ) {
                popup.appendChild(createMenu(_loc["move up"],null,moveUp));
                popup.appendChild(createMenu(_loc["move down"],null,moveDown));
            }
            
            _sm.lookup("wobzilla.popupFactory").showPopup(popup);
            event.stopPropagation();
            event.preventDefault();
        } catch (ex) {
            _log.error(ex);
        }
    }

    function select(event,args) {
        if (event.which == 2)
           return;
        event.returnValue = false;
        event.preventDefault();
        event.stopPropagation();

        var newSelectedEntry = args;
        //_log.debug("Selected " + newIndex );
        _selectionContext.select( _this, newSelectedEntry );
        return false;
    }
     
    function removeChild(event) {
        event.returnValue = false;
        event.preventDefault();
        event.stopPropagation();
        if (_removeButton.disabled || _selectedEntry == null)
            return false;

        var model = _selectedEntry.model;

        _sm.lookup("wobzilla.transaction").start();
        WBZ_remove(model.parentNode, model);
        _sm.lookup("wobzilla.transaction").commit();
        return false;
    }

    function moveUp(event) {
        move(event,-1);
    }

    function moveDown(event) {
        move(event,1);
    }

    /* Move one child up/down */
    function move(event,direction) {
        try {
            var model = _selectedEntry.model;
            var parentModel = model.parentNode;
            if (direction == -1) {
                var previous = WBZ_previousElementSibling(model);
                if (previous == null) {
                    return;
                }
                _sm.lookup("wobzilla.transaction").start();
                parentModel.removeChild(model);
                WBZ_insertBefore(parentModel, model, previous);
                _sm.lookup("wobzilla.transaction").commit();
            } else {
                var next = WBZ_nextElementSibling(model);
                if (next == null) {
                    return;
                }
                _sm.lookup("wobzilla.transaction").start();
                parentModel.removeChild(next);
                WBZ_insertBefore(parentModel, next, model);
                _sm.lookup("wobzilla.transaction").commit();
            }
            // find the entry for the model and select it
            var entry;
            for (var i=0;i<_entries.length;i++) {
                if ( _entries[i].model.isSameNode(model) ) {
                    entry = _entries[i];
                    break;
                }
            }
            _selectionContext.select( _this, entry);
        } catch (ex) {
            _log.error(ex);
        }
    }

    function editChild(event) {
        if (_editButton.disabled)
            return false;
        try {
            _editDialog.show();
        } catch (ex) {
            _log.error(ex);
        }
    } 

    function navigateUp(event) {
        navigate(event,-1);
    }

    function navigateDown(event) {
        navigate(event,1);
    }

    function navigate(event,args) {
        _log.debug("Navigate " + args);
        if ( _selectedEntry == null ) {
            return;
        }
        var newEntry =null;
        if (args == -1) {
            newEntry = _previousEntry;
        } else {
            newEntry = _nextEntry;
        }
        if (newEntry != null) {
            _selectionContext.select( _this, newEntry);
        }
    }

    function createButton(label,imgSrc) {
        var button = document.createElementNS(HTML_NS,"button");
        if (imgSrc != null) {
            var img = document.createElementNS(HTML_NS,"img");
            img.setAttribute("src",imgSrc);
            button.appendChild(img);
        }
        button.appendChild(document.createTextNode(label));
        button.setAttribute("class","smallButton");
        return button;
    }

    function enableButton(button,enable) {
        if (button == null)
            return;
        if (button.disabled == !enable)
            return;

        button.disabled = !enable;
        if (enable) {
            button.setAttribute("class","smallButton");
        } else {
            button.setAttribute("class","smallButtonDisabled");
        }
    }

    function createEntry(model, insertAfter, position, last) {
        var entry = new Object();
        var positionContext = new PositionContext(position,last);
        var context = new DefaultContext( _context );
        context.put( "wobzilla.position", positionContext );
        var childView = null;
        childView = _cf.createComponent(_viewConfig, _log, context, _sm);
        var output;
        if ( _table ) {
            output = document.createElementNS(HTML_NS,"tr");
            output.setAttribute("class","repeatNotSelectedTr");
        } else {
            output = document.createElementNS(HTML_NS,"div");
            output.setAttribute("class","repeatNotSelected");
        }
        WBZ_insertAfter(_outputNode, output, insertAfter);
        entry.view = childView;
        entry.outputStart = output;
        entry.model = model;
        entry.positionContext = positionContext;
        output.addEventListener("click",new Action(select,entry).action,false);
        output.addEventListener("select",new Action(select,entry).action,false);
        output.addEventListener("contextmenu",new Action(contextmenu,entry).action,false);

        return entry;
    }

    function initEntries() {
        for (var i = 0; i < _entries.length; i++) {
            var entry = _entries[i];
            if ( entry.initialized == null) {
                entry.view.init( entry.outputStart, entry.model, null );
                entry.initialized = true;
            }
        }
    }


    function newChildElement(event,createIndex) {
        event.returnValue = false;
        event.preventDefault();
        event.stopPropagation();
        if ( _log.debugging )
            _log.debug( "Create new " + createIndex );
        var prototype = WBZ_getFirstElement( _createConfigs[createIndex] );
        var newNode = prototype.cloneNode(true);
        var lastNode = ( _entries.length > 0 ) ? 
            _entries[_entries.length-1].model : null;
        _sm.lookup( "wobzilla.transaction" ).start();
        if ( lastNode != null ) {
            // insert after
            WBZ_insertAfter( lastNode.parentNode, newNode, lastNode );
        } else {
            var insertPoint = getInsertPoint();
            if (insertPoint != null) {
                WBZ_insertBefore( insertPoint.parentNode, newNode, insertPoint );
            } else {
                WBZ_insertBefore( _parentModel, newNode, _parentModel.firstChild );
            }
        }
        _sm.lookup("wobzilla.transaction").commit();
        // find new entry for model and select it 
        var entry;
        for (var i = 0; i < _entries.length; i++ ) {
            if ( _entries[i].model.isSameNode( newNode ) ) {
                entry = _entries[i];
                break;
            }
        }
        _selectionContext.select( _this, entry );

        if ( _editDialog != null ) {
            _editDialog.show();
        }
    }

    function removeEntry(entry) {
        _outputNode.removeChild(entry.outputStart);
        if ( entry == _selectedEntry ) {
            var newEntry = _nextEntry;
            if (newEntry == null) {
                newEntry = _previousEntry;
            }
            _selectedEntry = null;
            _selectionContext.select( _this, newEntry );
        }
        _cf.disposeComponent( entry.view );
    }
    
    /** returns the last node that matches 
        the xpath expression from the "at" attribute belonging
        to the create configuration node.
     */
    function getInsertPoint() {
        if ( _insertXPath == null)
            return null;
        var childNodes = _resolver.getNodes(_parentModel, _insertXPath, _context);
        if (childNodes.length == 0) {
            return null;
        } else {
            return WBZ_nextElementSibling(childNodes[childNodes.length-1]);
        }
    }

    function Action(method,arg) {
        var _method = method;
        var _arg = arg;
        this.action = function(event) {
           _method(event,_arg);
        } 
    }

    function EditDialog() {
        var _viewConfig;
        var _title;
        var _left;
        var _top;
        var _width;
        var _height;
        var _window;
        var _prevButton;
        var _nextButton;
        var _removeButton;
        var _dialogSm;
        var _outputNode;
        var _opening;
        var _dialogFactory = _sm.lookup("wobzilla.dialogFactory");
                
        var _this = this;
        this.view = null;

        this.configure = function(config) {
            _viewConfig = WBZ_wrapConfig(config);
            _title = WBZ_attribute(config,"title","");
            _left = WBZ_attribute(config,"left","300");
            _top = WBZ_attribute(config,"top","10");
            _width = WBZ_attribute(config,"width","500");
            _height = WBZ_attribute(config,"heigth","450");
        }

        this.setModel = function(model) {
            if ( _window == null ) {
                return;
            }

            var view = _this.view;
            if (view != null) {
                view.validate();
                _cf.disposeComponent( view );
            }

            view = _cf.createComponent( _viewConfig
                                        , _log
                                        , _context
                                        , _dialogSm
                                        );
            assertNotNull( _outputNode );
            assertNotNull( model );
            _model = model;
            WBZ_removeAll( _outputNode);
            view.init( _outputNode, model);
            _this.view = view;
            updateNavigate();
        }


        // DIALOG Methods
        this.show = function() {
            if ( _window == null && _opening != true) {
                _opening = true;
                _dialogFactory.createDialog("navigationDialog.xul"
                                            , _title
                                            , dialogOpened
                                            , dialogClosed
                                            , _left
                                            , _top
                                            , _width
                                            , _height
                                            );
            } else {
                if ( _window != null ) {
                    _window.focus();
                }
            }
        }
        
        this.close = function() {
            if ( _window != null ) {
                if ( _log.debugging ) {
                    _log.debug("Closing dialog");
                }
                _dialogFactory.closeDialog( _window );
            }
        }

        this.updateNavigate = function() {
            if ( _prevButton != null ) 
                _prevButton.disabled = ( _previousEntry == null );
            if ( _nextButton != null ) 
                _nextButton.disabled = ( _nextEntry == null );
        }

        function dialogClosed() {
            _log.debug("DIALOG CLOSED");
            if (_this.view != null) {
                try {
                    _this.view.validate();
                } catch (ex) {
                    _log.error(ex);
                }
                _cf.disposeComponent( _this.view );
                _this.view = null;
            }
            _window = null;
        }

        function dialogOpened(dialogWindow) {
            _opening = false;
            try {
                _window = dialogWindow;
                var editWindow = dialogWindow.document.getElementById('edit').contentWindow;

                var body = editWindow.document.getElementsByTagName("body")[0];
                _outputNode = document.createElementNS(HTML_NS,"div");
                WBZ_removeAll(body);
                body.appendChild( _outputNode);
                var menu = _window.document.getElementById("repeatMenu");
                WBZ_removeAll(menu);
                for (var i = 0; i < _createConfigs.length; i++) {
                    var label = _createConfigs[i].getAttribute("label");
                    var button = createXULButton((i+1)+ " " +label,"images/new.gif");
                    button.setAttribute("accesskey",""+ (i+1)); 
                    menu.appendChild(button);
                    button.addEventListener("command",new Action(newChildElement,i).action,true);
                    //button.addEventListener("command",test,true);
                }
                _prevButton = _window.document.getElementById("prev");
                _nextButton = _window.document.getElementById("next");
                _removeButton = _window.document.getElementById("remove");
                _prevButton.addEventListener("command",navigateUp,true);
                _nextButton.addEventListener("command",navigateDown,true);
                _removeButton.addEventListener("command",removeChild,true);

                // new serviceManager for the repeat dialog
                _dialogSm = new DefaultServiceManager(_sm);
                _dialogSm.put("wobzilla.selectionContext",new DefaultSelectionContext());
                _dialogSm.put("wobzilla.popupFactory",new DefaultPopupFactory(editWindow));

                if ( _selectedEntry != null) {
                    _this.setModel( _selectedEntry.model);
                }
            } catch (ex) {
                _log.error(ex);
            }
        }

        function createXULButton(label,imgSrc) {
            var button = document.createElementNS(XUL_NS,"toolbarbutton");
            if (imgSrc != null) {
                button.setAttribute("image",imgSrc);
            }
            button.setAttribute("label",label);
            //button.setAttribute("class","smallButton");
            return button;
        }
        
    }
}


