/** 
 * Configuration:
 * <pre>
 *   &lt;wbz:view class="WbzValueOf" select="&#64;name"/>
 * </pre>
 *  or 
 * <pre>
 *   &lt;wbz:value-of select="&#64;name"/>
 * </pre>
 *
 * @constructor
 * @requires wobzilla_componentFactory
 * @requires wobzilla_xpath
*/
function WbzValueOf() {
    var _resolver;
    var _context;
    var _xpath;
    var _textNode;
    var _parentModel;

    /** 
     * contextualizes
     */
    this.contextualize = function(context) {
        _context = context;
    }

    this.service = function(serviceManager) {
        _resolver = serviceManager.lookup("wobzilla.xpath");
    }
    
    this.configure = function(config) {
        _xpath = config.getAttribute("select");
    }

    this.init = function(outputNode,parentModel,insertAfter) {
        _parentModel = parentModel;
        var value = _resolver.getText(_parentModel,_xpath, _context);
        _textNode = document.createTextNode(value);
        WBZ_insertAfter(outputNode,_textNode,insertAfter);
        insertAfter = _textNode;
        return insertAfter;
    }

    this.requery = function(changes) {
        var value = _resolver.getText(_parentModel,_xpath,_context);
        if (value != _textNode.nodeValue) {
            _textNode.nodeValue = value;
        }
    }

    /** 
     * we don't need to validate value-of. This method does nothing. 
     */
    this.validate = function() {
    }
}
